package cn.ibizlab.humanresource.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.base.domain.HROMHIERARCHYPURPOSE;
import cn.ibizlab.humanresource.core.base.filter.HROMHIERARCHYPURPOSESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HROMHIERARCHYPURPOSE] 服务对象接口
 */
public interface IHROMHIERARCHYPURPOSEService extends IService<HROMHIERARCHYPURPOSE>{

    boolean create(HROMHIERARCHYPURPOSE et) ;
    void createBatch(List<HROMHIERARCHYPURPOSE> list) ;
    boolean update(HROMHIERARCHYPURPOSE et) ;
    void updateBatch(List<HROMHIERARCHYPURPOSE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HROMHIERARCHYPURPOSE get(String key) ;
    HROMHIERARCHYPURPOSE getDraft(HROMHIERARCHYPURPOSE et) ;
    boolean checkKey(HROMHIERARCHYPURPOSE et) ;
    boolean save(HROMHIERARCHYPURPOSE et) ;
    void saveBatch(List<HROMHIERARCHYPURPOSE> list) ;
    Page<HROMHIERARCHYPURPOSE> searchDefault(HROMHIERARCHYPURPOSESearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HROMHIERARCHYPURPOSE> getHromhierarchypurposeByIds(List<String> ids) ;
    List<HROMHIERARCHYPURPOSE> getHromhierarchypurposeByEntities(List<HROMHIERARCHYPURPOSE> entities) ;
}


